#include <stdio.h>
#include <m17n.h>

int
main (int argc, char **argv)
{
  MSymbol imname;
  char filename[256];
  MText *mt;
  MSymbol utf_8, key;
  MInputMethod *im;
  MInputContext *ic;
  int c;
  char byte[2];

  M17N_INIT ();

  if (argc < 2)
    {
      fprintf (stderr, "Usage: %s CONVERTER-NAME\n", argv[0]);
      exit (1);
    }
  imname = msymbol (argv[1]);
  sprintf (filename, "%s.cnv", argv[1]);
  mdatabase_define (msymbol ("input-method"), Mt, imname, Mnil,
		    NULL, filename);
  im = minput_open_im (Mt, imname, NULL);
  if (! im)
    {
      fprintf (stderr, "IM-Open failed: %s\n", argv[1]);
      exit (1);
    }
  ic = minput_create_ic (im, NULL);
  if (! ic)
    {
      fprintf (stderr, "IC-Create failed: %s\n", argv[1]);
      exit (1);
    }
  byte[1] = '\0';
  mt = mtext ();
  utf_8 = msymbol ("utf-8");
  while ((c = getchar ()) != EOF)
    {
      byte[0] = c;
      key = msymbol (byte);
      if (minput_filter (ic, key, NULL) == 0)
	{
	  if (minput_lookup (ic, key, NULL, mt) < 0)
	    {
	      fflush (stdout);
	      fprintf (stderr, "Filtering `0x%02X' failed\n", c);
	      exit (1);
	    }
	  mconv_encode_stream (msymbol ("utf-8"), mt, stdout);
	  mtext_del (mt, 0, mtext_len (mt));
	}
    }      
  minput_destroy_ic (ic);
  minput_close_im (im);
  m17n_object_unref (mt);
  M17N_FINI ();
  exit (0);
}
