#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <m17n.h>

int
main ()
{
  MPlist *script_list, *plist;

  M17N_INIT ();

  script_list = mscript_list ();
  for (plist = script_list; mplist_key (plist) != Mnil;
       plist = mplist_next (plist))
    {
      MSymbol script = mplist_value (plist);
      MPlist *lang_list = mscript_language_list (script);

      printf ("SCRIPT=%s\n", msymbol_name (script));

      if (lang_list)
	for (; mplist_key (lang_list) != Mnil;
	     lang_list = mplist_next (lang_list))
	  {
	    MSymbol language = mplist_value (lang_list);

	    printf ("  LANGUAGE=%s\n", msymbol_name (language));
	  }
    }
  m17n_object_unref (script_list);

  M17N_FINI ();
  exit (0);
}
