#include <stdio.h>
#include <stdlib.h>
#include <m17n.h>

int
main (int argc, char **argv)
{
  MInputMethod *im;
  MInputContext *ic;
  unsigned char byte[2];
  int i;
  MSymbol prop, alias, sym;

  M17N_INIT ();
  im = minput_open_im (Mt, msymbol ("test"), NULL);
  if (im)
    {
      ic = minput_create_ic (im, NULL);
      if (ic)
	{
	  byte[0] = 0xd1;
	  byte[1] = 0;
	  minput_filter (ic, msymbol (byte), NULL);
	  minput_destroy_ic (ic);
	}
      minput_close_im (im);
    }
  prop = msymbol ("  key-alias");
  byte[1] = 0;
  for (i = 0; i < 256; i++)
    {
      byte[0] = i;
      sym = msymbol ((char *) byte);
      alias = msymbol_get (sym, prop);
      if (alias)
	{
	  printf ("%02X:", i);
	  while (alias && alias != sym)
	    {
	      printf (" %s", msymbol_name (alias));
	      alias = msymbol_get (alias, prop);
	    }
	  printf ("\n");
	}
    }

  exit (0);
}
