/* XML の解析 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlreader.h>
#include <libxml/xmlmemory.h>

void
error_exit (char *fmt, const char *arg)
{
  fprintf (stderr, fmt, arg);
  fprintf (stderr, "\n");
  exit (1);
}

int
main (int argc, char **argv)
{
#if 0
  XPathContextPtr context;
  xmlXPathObjectPtr result;
  xmlChar *xpath = (xmlChar *) "//input-method";
  xmlNodeSetPtr nodeset;
#endif
  const xmlChar *name, *value;
  xmlTextReaderPtr reader;
  int depth;

  reader = xmlReaderForFile (argv[1], "utf-8",
			     XML_PARSE_NOBLANKS
			     /*XML_PARSE_XINCLUDE|XML_PARSE_NOENT*/);
  /*xmlTextReaderRelaxNGValidate (reader, argv[2]);*/
  if (xmlTextReaderRead (reader) != 1)
    error_exit ("Read error: %s", argv[1]);
  if (! (name = xmlTextReaderConstLocalName (reader)))
    error_exit ("No %s node", "input-method");
  printf ("%s", (char *) name);
  xmlTextReaderRead (reader);
  if (! (name = xmlTextReaderConstLocalName (reader)))
    error_exit ("No inner node: %s", "tags");
  printf (" %s", (char *) name);
  xmlTextReaderRead (reader);
  printf (" %s", (char *) xmlTextReaderConstLocalName (reader));
  xmlTextReaderRead (reader);
  printf (" %s", (char *) xmlTextReaderConstLocalName (reader));
  depth = xmlTextReaderDepth(reader);
  value = xmlTextReaderConstValue (reader);
  printf (" \"%s\"", (char *) value);
  xmlTextReaderRead (reader);
  xmlTextReaderRead (reader);
  xmlTextReaderRead (reader);
  value = xmlTextReaderConstValue (reader);
  printf (" \"%s\"", (char *) value);
  do { xmlTextReaderRead (reader); }
  while (xmlTextReaderNodeType (reader) != XML_READER_TYPE_TEXT);
  value = xmlTextReaderConstValue (reader);
  if (depth == xmlTextReaderDepth(reader))
    printf (" \"%s\"", (char *) value);
  printf ("\n");

#if 0
  xmlTextReaderRelaxNGValidate (reader, argv[2]);
  while ((i = xmlTextReaderRead (reader)) == 1);
  printf ("%d\n\n", i);
#endif

#if 0
  doc = xmlParseFile (argv[1]);
  if (! doc)
    error_exit ("Invalid XML file: %s", argv[1]);
  context = xmlXPathNewContext (doc);
  result = xmlXPathEvalExpression (xpath, context);
  if (! result)
    error_exit ("Error in xmlXPathEvalExpression for: %s", (char *) xpath);
  xmlXPathFreeContext (context);
  if (xmlXPathNodeSetIsEmpty (result->nodesetval))
    error_exit ("Can't find the node: %s", (char *) xpath);
  nodeset = result->nodesetval;
  for (i = 0; i < nodeset->nodeNr; i++)
    {
      key = xmlGetProp (nodeset->nodeTab[i], "input-method-name");
      printf ("input-method-name: %s\n", key);
      xmlFree (key);
      key = xmlGetProp (nodeset->nodeTab[i], "language");
      printf ("langauge: %s\n", key);
      xmlFree (key);
      key = xmlGetProp (nodeset->nodeTab[i], "extra-id");
      if (key)
	{
	  printf ("extra-id: %s\n", key);
	  xmlFree (key);
	}
    }
  xmlXPathFreeObject (result);
#endif
  exit (0);
}
